// MoveExe.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MoveExe.h"

#include "MainFrm.h"
#include "MoveExeDoc.h"
#include "MoveExeView.h"
#include "DlgPassword.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
//  
BOOL MoveFileOnReboot (LPCTSTR pszExisting, LPCTSTR pszNew)
{
	//     
	BOOL bResult = FALSE;

	//   : =
	char	szRenameLine[1024];   
	// ;   
	int		cchRenameLine = wsprintfA(szRenameLine, 
#ifdef UNICODE
		"%ls=%ls\r\n", 
#else      
		"%hs=%hs\r\n", 
#endif
		(pszNew == NULL) ? __TEXT("NUL") : pszNew, pszExisting); // NULL,    NUL=

	//     WININIT.INI,
	char szRenameSec[] = "[Rename]\r\n";
	//    
	int cchRenameSec = sizeof(szRenameSec) - 1; 
	
	HANDLE hfile, hfilemap;
	DWORD dwFileSize, dwRenameLinePos;
	TCHAR szPathnameWinInit[_MAX_PATH];
	//    WININIT.INI
	GetWindowsDirectory(szPathnameWinInit, _MAX_PATH);
	lstrcat(szPathnameWinInit, __TEXT("\\WinInit.Ini"));
	//    WININIT.INI.
	hfile = CreateFile(szPathnameWinInit,      
			GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, 
			FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if(hfile == INVALID_HANDLE_VALUE)			 
		return bResult;
	// hfilemap      
	//  
	dwFileSize = GetFileSize(hfile, NULL);
	hfilemap = CreateFileMapping(hfile, NULL, PAGE_READWRITE, 0, 
								dwFileSize + cchRenameLine + cchRenameSec, NULL);
	if(hfilemap != NULL) 
	{
		// WININIT.INI  . 
		LPSTR pszWinInit = (LPSTR)MapViewOfFile(hfilemap, 
												FILE_MAP_WRITE, 0, 0, 0);	      
		if(pszWinInit != NULL) 
		{
			//   [Rename] 
			LPSTR pszRenameSecInFile = strstr(pszWinInit, szRenameSec);
			if(pszRenameSecInFile == NULL) 
			{
				//  -  .
				dwFileSize += wsprintfA(&pszWinInit[dwFileSize], "%s",
										szRenameSec);
				//   
				dwRenameLinePos = dwFileSize;            
			} 
			else 
			{
				// 
				PSTR pszFirstRenameLine = strchr(pszRenameSecInFile, '\n');
				//       , 
				//       
				pszFirstRenameLine++;	// 1-   
				memmove(pszFirstRenameLine + cchRenameLine, pszFirstRenameLine, 
					pszWinInit + dwFileSize - pszFirstRenameLine);		            
				//     
				dwRenameLinePos = pszFirstRenameLine - pszWinInit;	         
			}
			//  
			memcpy(&pszWinInit[dwRenameLinePos], szRenameLine,cchRenameLine);
			
			UnmapViewOfFile(pszWinInit);
			//   .
			dwFileSize += cchRenameLine;				
			bResult = TRUE;//...   
		}
		CloseHandle(hfilemap);		
	}
	// EOF.
	SetFilePointer(hfile, dwFileSize, NULL, FILE_BEGIN);
	SetEndOfFile(hfile);		
	CloseHandle(hfile);   

	return bResult;
}

/////////////////////////////////////////////////////////////////////////////
// CMoveExeApp

BEGIN_MESSAGE_MAP(CMoveExeApp, CWinApp)
	//{{AFX_MSG_MAP(CMoveExeApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMoveExeApp construction

CMoveExeApp::CMoveExeApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMoveExeApp object

CMoveExeApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMoveExeApp initialization

BOOL CMoveExeApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CMoveExeDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CMoveExeView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	
	CDlgPassword	dlgPass;
	dlgPass.DoModal();
//	m_pMainWnd->ShowWindow(SW_SHOW);
//	m_pMainWnd->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMoveExeApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMoveExeApp message handlers

